"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TuyaGetRequestGeneralData = exports.TuyaDevice = void 0;
var __1 = require("../");
var TuyaDevice = /** @class */ (function () {
    function TuyaDevice(deviceID) {
        this.deviceID = deviceID;
        this.cloudResponseString = '';
        this.tuyaGetRequestGeneralData = new TuyaGetRequestGeneralData();
    }
    TuyaDevice.prototype.retrieveGetRequestGeneralData = function (tuyaCloudResponse) {
        return __awaiter(this, void 0, void 0, function () {
            var succesMatch, successTuya, timestampMatch, timestampTuya, timezoneMatch, timezoneTuya, thingsboardRequestTime, deviceNameMatch, deviceNameTuya, deviceStatusMatch, deviceStatusTuya, thingsboardDeviceStatus, updateTimeMatch, updateTime, thingsboardUpdateTime;
            return __generator(this, function (_a) {
                // Convert the cloud response to a string
                this.cloudResponseString = JSON.stringify(tuyaCloudResponse);
                succesMatch = this.cloudResponseString.match(/"\bsuccess\b":(.*?),/);
                successTuya = succesMatch ? succesMatch[1] : null;
                if (successTuya == null || successTuya.toString() != 'true') {
                    throw new Error('The GET request to Tuya Cloud failed!Exiting');
                }
                timestampMatch = this.cloudResponseString.match(/"t":(\d+),/);
                timestampTuya = timestampMatch ? timestampMatch[1] : null;
                if (timestampTuya == null)
                    throw new Error('Could not retrieve unix timestamp!');
                timezoneMatch = this.cloudResponseString.match(/"time_zone":"(.*?)"/);
                timezoneTuya = timezoneMatch ? timezoneMatch[1] : null;
                if (timezoneTuya == null)
                    throw new Error('Could not retrieve timezone!');
                thingsboardRequestTime = __1.BaseUtils.unixTimestampToLocalTime13D(timestampTuya, timezoneTuya);
                if (thingsboardRequestTime == undefined)
                    throw new Error('Could not convert the request time to designated format!');
                deviceNameMatch = this.cloudResponseString.match(/"name":"(.*?)",/);
                deviceNameTuya = deviceNameMatch ? deviceNameMatch[1] : null;
                if (deviceNameTuya == null)
                    throw new Error('Could not retrieve device name!');
                deviceStatusMatch = this.cloudResponseString.match(/"online":(.*?),/);
                deviceStatusTuya = deviceStatusMatch ? deviceStatusMatch[1] : null;
                if (deviceStatusTuya == null)
                    throw new Error('Could not retrieve device status!');
                thingsboardDeviceStatus = deviceStatusTuya == 'true' ? 'online' : 'offline';
                updateTimeMatch = this.cloudResponseString.match(/"update_time":(\d+),/);
                updateTime = updateTimeMatch ? updateTimeMatch[1] : null;
                if (updateTime == null)
                    throw new Error('Could not retrieve when the device was last updated!');
                thingsboardUpdateTime = __1.BaseUtils.unixTimestampToLocalTime10D(updateTime, timezoneTuya);
                if (thingsboardUpdateTime == undefined)
                    throw new Error('Could not convert the request time to designated format!');
                this.tuyaGetRequestGeneralData.setData(thingsboardRequestTime, successTuya.toString() == 'true', deviceNameTuya, thingsboardDeviceStatus, thingsboardUpdateTime);
                return [2 /*return*/];
            });
        });
    };
    return TuyaDevice;
}());
exports.TuyaDevice = TuyaDevice;
var TuyaGetRequestGeneralData = /** @class */ (function () {
    function TuyaGetRequestGeneralData() {
        this._timestamp = '';
        this._success = false;
        this._deviceName = '';
        this._deviceStatus = '';
        this._updateTime = '';
    }
    // ======================= GETTERS & SETTERS =======================
    TuyaGetRequestGeneralData.prototype.setData = function (timestamp, success, deviceName, deviceStatus, updateTime) {
        this.timestamp = timestamp;
        this.success = success;
        this.deviceName = deviceName;
        this.deviceStatus = deviceStatus;
        this.updateTime = updateTime;
    };
    Object.defineProperty(TuyaGetRequestGeneralData.prototype, "timestamp", {
        get: function () {
            return this._timestamp;
        },
        set: function (value) {
            this._timestamp = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TuyaGetRequestGeneralData.prototype, "success", {
        get: function () {
            return this._success;
        },
        set: function (value) {
            this._success = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TuyaGetRequestGeneralData.prototype, "deviceName", {
        get: function () {
            return this._deviceName;
        },
        set: function (value) {
            this._deviceName = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TuyaGetRequestGeneralData.prototype, "deviceStatus", {
        get: function () {
            return this._deviceStatus;
        },
        set: function (value) {
            this._deviceStatus = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TuyaGetRequestGeneralData.prototype, "updateTime", {
        get: function () {
            return this._updateTime;
        },
        set: function (value) {
            this._updateTime = value;
        },
        enumerable: false,
        configurable: true
    });
    return TuyaGetRequestGeneralData;
}());
exports.TuyaGetRequestGeneralData = TuyaGetRequestGeneralData;
